# rtotin.sml
# Converts elevation raster to TIN object as contour lines.

# Globals
class RASTER Rin;
class TIN Tout;

GetInputRaster(Rin);
GetOutputTIN(Tout);

numeric range = GlobalMax(Rin) - GlobalMin(Rin);

numeric zTolerance = range / 100;
numeric maxNodes = 1000;
numeric zDelta = 0;
numeric shortEdge = 0;
numeric longEdge = 0;
string flags$ = "";

RasterToTINIterative2(Tout, Rin,  zTolerance, maxNodes, zDelta, shortEdge, longEdge, flags$);
CloseRaster(Rin);
print ("Process Completed.", "TIN#Edges:", Tout.$Info.NumEdges, "TIN#Nodes:",Tout.$Info.NumNodes);

